#
# Copyright (C) 2007 by Johan De Taeye
#
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
#

# file : $URL: https://frepple.svn.sourceforge.net/svnroot/frepple/trunk/contrib/django/freppledb/common/__init__.py $
# revision : $LastChangedRevision: 881 $  $LastChangedBy: jdetaeye $
# date : $LastChangedDate: 2008-12-30 14:23:09 +0100 (Tue, 30 Dec 2008) $

r'''
An reusable application that contains common functionality of different
frePPLe data models.

The common functionality handles:
  - breadcrumbs
  - user preferences: reporting buckets, report start and end dates, report output type
  - login using the e-mail address
  - date and time bucket definition
'''

from django import template

# Make our tags built-in, so we don't have to load them any more in our
# templates with a 'load' tag.
template.add_to_builtins('common.templatetags.breadcrumbs')
